VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "RegistryEntry"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' registry entry important stuff
Public rgeEntry$
Public rgeDataType&
Public rgeValue$
Public rgeMainKey&
Public rgeSubKey$
Public Sub rgeExtractKeys()
    '------------------------------------------------------------------
    'Enter with RegistryEntry.rgeSubKey containing a full path in the
    'My Computer\HKEY_...\..\ format or HKEY_...\...\ format
    '--------------------------------------------------------------
    If Left$(rgeSubKey, 12) = "My Computer\" Then
        rgeSubKey = Right$(rgeSubKey, Len(rgeSubKey) - 12)
    End If
    
    '----------------------------------------------------------------
    'If there is no main key we have to assume it may already have
    'been extracted.
    '---------------------------------------------------------------
    If Left$(rgeSubKey, 5) <> "HKEY_" Then
        Exit Sub
    ElseIf InStr(rgeSubKey, "\") = 0 Then
        rgeMainKey = GetMainKey(rgeSubKey)
        rgeSubKey = ""
    Else
        rgeMainKey = GetMainKey(Left$(rgeSubKey, InStr(rgeSubKey, "\") - 1))
        rgeSubKey = Right$(rgeSubKey, Len(rgeSubKey) - InStr(rgeSubKey, "\"))
    End If
    ' -----------------------------------------------------
    ' Check RegEntry.rgeMainKey& for validity
    ' -----------------------------------------------------
    If rgeMainKey < &H80000000 Or rgeMainKey > &H80000006 Then
        rgeClear
    End If
        

End Sub

Public Sub rgeClear()
    rgeMainKey = 0
    rgeSubKey = ""
    rgeValue = ""
    rgeDataType = 0
    rgeEntry = ""
End Sub

