VERSION 4.00
Begin VB.Form Form2 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   Caption         =   "Form2"
   ClientHeight    =   2784
   ClientLeft      =   2760
   ClientTop       =   3432
   ClientWidth     =   5520
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   7.8
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   3120
   Left            =   2712
   LinkTopic       =   "Form2"
   ScaleHeight     =   2784
   ScaleWidth      =   5520
   Top             =   3144
   Width           =   5616
   Begin VB.Frame Frame1 
      Caption         =   "Base"
      Height          =   912
      Left            =   360
      TabIndex        =   7
      Top             =   1680
      Visible         =   0   'False
      Width           =   2232
      Begin VB.OptionButton Option1 
         Caption         =   "Decimal"
         Height          =   252
         Index           =   1
         Left            =   360
         TabIndex        =   0
         Top             =   540
         Width           =   1512
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Hexadecimal"
         Height          =   252
         Index           =   0
         Left            =   360
         TabIndex        =   8
         Top             =   240
         Value           =   -1  'True
         Width           =   1512
      End
   End
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   312
      Index           =   1
      Left            =   4140
      TabIndex        =   6
      Top             =   1920
      Width           =   912
   End
   Begin VB.CommandButton Command1 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   312
      Index           =   0
      Left            =   2940
      TabIndex        =   5
      Top             =   1920
      Width           =   912
   End
   Begin VB.TextBox Text2 
      Height          =   312
      Left            =   300
      TabIndex        =   4
      Top             =   1260
      Width           =   4812
   End
   Begin VB.TextBox Text1 
      BackColor       =   &H00C0C0C0&
      Enabled         =   0   'False
      Height          =   312
      Left            =   300
      TabIndex        =   2
      Top             =   420
      Width           =   4812
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Caption         =   "Value Data:"
      ForeColor       =   &H80000008&
      Height          =   312
      Left            =   360
      TabIndex        =   3
      Top             =   840
      Width           =   1632
   End
   Begin VB.Label Label2 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Caption         =   "Value Name:"
      ForeColor       =   &H80000008&
      Height          =   252
      Left            =   360
      TabIndex        =   1
      Top             =   60
      Width           =   2172
   End
End
Attribute VB_Name = "Form2"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Private bPainted As Boolean

Private Sub Command1_Click(iIndex%)
    Dim nRtn&
    Dim varTempVar
    Dim Item As ListItem
    Select Case iIndex
        Case 0
            
            '-------------------------------------------------
            'OK was clicked
            'Values were loaded into visible and
            'hidden text boxes by the EditRegValue function.
            '-------------------------------------------------
            RegEntry.rgeValue = text2
            RegEntry.rgeEntry = Text1
            If RegEntry.rgeEntry = "(Default)" Then
                
                '---------------------------------------------
                'We are visually displaying (Default) when the
                'value name is null.
                '---------------------------------------------
                RegEntry.rgeEntry = ""
            End If

            '-------------------------------------------------
            'We handle DWORDs differently than strings
            '-------------------------------------------------
            If RegEntry.rgeDataType = REG_DWORD Then
                
                '---------------------------------------------
                'We do some tortuous maneuvers to make sure
                'that all values are hex longs, including decimal
                'values greater than 7FFFFFFF
                '---------------------------------------------
                varTempVar = text2
                If Option1(0) Then
                    varTempVar = "&H" & varTempVar
                End If
                If IsNumeric(varTempVar) Then
                    If Option1(0) Then
                        RegEntry.rgeValue = text2
                    Else
                        fTempDbl = Val(text2 & "#")
                        If fTempDbl > &H7FFFFFFF Then
                            RegEntry.rgeValue = Hex$(fTempDbl - 4294967296#)
                        Else
                            RegEntry.rgeValue = Hex$(fTempDbl)
                        End If
                    End If
                Else
                    '-----------------------------------------
                    'We have a DWORD value, but the text box
                    'does not contain an number.
                    '-----------------------------------------
                    Exit Sub
                End If
            End If
            
            '-------------------------------------------------
            'Write new value to the registry
            '-------------------------------------------------
            RegSetValue
            
            '-------------------------------------------------
            'If the value was successfully changed, update the list box
            '-------------------------------------------------
            If nRtn = 0 Then
                RegEntry.rgeEntry = Text1 'Get "Default" back
                If RegEntry.rgeDataType = REG_SZ Then
                    RegEntry.rgeValue = """" & RegEntry.rgeValue & """"
                End If
                If RegEntry.rgeDataType = REG_DWORD Then
                    
                    '-----------------------------------------
                    'Tortuous calculations again to display positive
                    'integer values greater than a VB long may contain.
                    '-----------------------------------------
                    fTempDbl = Val("&H" & RegEntry.rgeValue)
                    If fTempDbl < 0 Then
                        fTempDbl = fTempDbl + 4294967296#
                    End If
                    If Right$(RegEntry.rgeValue, 1) = "&" Then
                        RegEntry.rgeValue = Left$(RegEntry.rgeValue, Len(RegEntry.rgeValue) - 1)
                    End If
                    RegEntry.rgeValue = UCase(RegEntry.rgeValue) & " (" & Format$(fTempDbl) & ")"
                End If
                
                Set Item = Form1!ListView1.ListItems.Item(Form1!ListView1.SelectedItem.Index)
                Item.SubItems(1) = RegEntry.rgeValue
            End If
            Unload Form2
    
        Case 1
            
            '-------------------------------------------------
            'Cancel was clicked
            '-------------------------------------------------
            Unload Form2
    End Select
End Sub

Private Sub Form_Load()
    CenterForm Me
End Sub

Private Sub Form_Paint()
    If Not bPainted Then
        bPainted = True
        text2.SelStart = 0
        text2.SelLength = Len(text2) + 1
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
bPainted = False
End Sub

Private Sub Option1_Click(iIndex%)
Select Case iIndex
    Case 0
        
        '------------------------------------------
        'Convert from decimal to Hex
        '------------------------------------------
        sTempString = text2
        If Val(sTempString) < 0 Then
            
            '--------------------------------------
            'Force values that otherwise would be
            'given negative integer numbers to type
            'long.
            '--------------------------------------
            sTempString = sTempString & "&"
        End If
        fTempDbl = Val(text2 & "#")
            
            '--------------------------------------
            'Hex function will fail on values outside
            'the normal VB long range.  Convert such
            'to a negative value within the range
            '--------------------------------------
            If fTempDbl > &H7FFFFFFF Then
                text2 = Hex$(fTempDbl - 4294967296#)
            Else
                text2 = Hex$(fTempDbl)
            End If
    Case 1
        
        '------------------------------------------
        'Convert from Hex to decimal
        '------------------------------------------
        sTempString = text2
        If Len(sTempString) < 5 Then
            
            '--------------------------------------
            'Force values that otherwise would be
            'given negative integer numbers to type
            'long.
            '--------------------------------------
            sTempString = sTempString & "&"
        End If
        fTempDbl = Val("&H" & sTempString)
        If fTempDbl < 0 Then
            
            '--------------------------------------
            'Val function will return a negative long
            'for hex numbers greater than 7FFFFFFF.
            'Convert these to positive values for
            'display purposes.
            '--------------------------------------
            fTempDbl = fTempDbl + 4294967296#
        End If
        text2 = Format$(fTempDbl)
End Select
End Sub

