VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Form1"
   ClientHeight    =   2532
   ClientLeft      =   2772
   ClientTop       =   2592
   ClientWidth     =   4716
   Height          =   2868
   Icon            =   TASKBAR.FRX:0000
   Left            =   2724
   LinkTopic       =   "Form1"
   ScaleHeight     =   2532
   ScaleWidth      =   4716
   Top             =   2304
   Width           =   4812
   Begin CommandButton Command5 
      Caption         =   "Exit"
      Height          =   372
      Left            =   3300
      TabIndex        =   4
      Top             =   1680
      Width           =   732
   End
   Begin CommandButton Command1 
      Caption         =   "Command1"
      DragIcon        =   TASKBAR.FRX:0302
      Height          =   432
      Left            =   360
      TabIndex        =   0
      Top             =   120
      Width           =   1452
   End
   Begin Timer Timer1 
      Enabled         =   0   'False
      Interval        =   2000
      Left            =   2280
      Top             =   1440
   End
   Begin MsgHook MsgHook1 
      Left            =   2280
      Top             =   1920
   End
   Begin CommandButton Command4 
      Caption         =   "Command4"
      DragIcon        =   TASKBAR.FRX:0604
      Height          =   432
      Left            =   360
      TabIndex        =   3
      Top             =   1920
      Width           =   1452
   End
   Begin CommandButton Command3 
      Caption         =   "Command3"
      DragIcon        =   TASKBAR.FRX:0906
      Height          =   432
      Left            =   360
      TabIndex        =   2
      Top             =   1320
      Width           =   1452
   End
   Begin CommandButton Command2 
      Caption         =   "Command2"
      DragIcon        =   TASKBAR.FRX:0C08
      Height          =   432
      Left            =   360
      TabIndex        =   1
      Top             =   720
      Width           =   1452
   End
   Begin Label Label4 
      Alignment       =   2  'Center
      Height          =   252
      Left            =   3120
      TabIndex        =   8
      Top             =   900
      Width           =   852
   End
   Begin Label Label3 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Icon:"
      Height          =   252
      Left            =   2460
      TabIndex        =   7
      Top             =   900
      Width           =   492
   End
   Begin Label Label2 
      Alignment       =   2  'Center
      Height          =   252
      Left            =   2460
      TabIndex        =   6
      Top             =   540
      Width           =   2052
   End
   Begin Label Label1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Mouse Event:"
      Height          =   252
      Left            =   2460
      TabIndex        =   5
      Top             =   180
      Width           =   1512
   End
End
Option Explicit
Dim sTempString$
Dim iIconUsed%
Dim lIconAdded%
Const iFormIcon = 0
Const iCommand1Icon = 1
Const iCommand2Icon = 2
Const iCommand3Icon = 3

Sub Command1_Click ()

'-----------------------------------------------------
'This button adds a new icon to the tray.
'-----------------------------------------------------

    '---------------------------------------------------
    'Select one of the icons embedded in the controls:
    '---------------------------------------------------

    Select Case iIconUsed
	Case 0
	    structNotify.hIcon = command1.DragIcon
	    iIconUsed = 1
	Case 1
	    structNotify.hIcon = command2.DragIcon
	    iIconUsed = 2
	Case 2
	    structNotify.hIcon = command3.DragIcon
	    iIconUsed = 3
	Case 3
	    structNotify.hIcon = command4.DragIcon
	    iIconUsed = 4
	Case 4
	    structNotify.hIcon = Me.Icon
	    iIconUsed = 0
    End Select

    '------------------------------------------------------------
    'Select a unique number for use during callbacks.  lIconAdded
    'was set to -1 during Form_Load
    '------------------------------------------------------------
    lIconAdded = lIconAdded + 1
    structNotify.lID = lIconAdded

    structNotify.lFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
    ltemplong = Shell_NotifyIcon(NIM_ADD, structNotify, idShell_NotifyIcon)

End Sub

Sub Command2_Click ()
    '--------------------------------------------------------
    'This routine changes the text a user will see when placing
    'the mouse over a tray icon.  Since structNotify.lID is not
    'changed, this will affect the last icon added and any future
    'icons until the .sTip property is changed again.
    '--------------------------------------------------------

    sTempString = InputBox("New text", , structNotify.sTip)
    If Len(sTempString) > 63 Then sTempString = Left$(sTempString, 63)
    structNotify.sTip = sTempString & Chr$(0)
    structNotify.lFlags = NIF_TIP
    ltemplong = Shell_NotifyIcon(NIM_MODIFY, structNotify, idShell_NotifyIcon)


End Sub

Sub Command3_Click ()
    '--------------------------------------------------
    'This routine demonstrates changing the icon under
    'program control, cyling among four different icons
    'For convenience these are stored in the DragIcon
    'Properties of the three command buttons.  Bitmaps
    'that are not icons will not work, such as Image
    'properties.
    'Icon modification would routinely be used as a status
    'indicator.  For example, the Win95 Dial-Up utility
    'places a modem with read and send indicators that cycle
    'between red and green.
    'Since structNotify.lID is not changed, this will affect
    'only the last icon loaded.
    '--------------------------------------------------

    Select Case iIconUsed
	Case 0
	    structNotify.hIcon = command1.DragIcon
	    iIconUsed = 1
	Case 1
	    structNotify.hIcon = command2.DragIcon
	    iIconUsed = 2
	Case 2
	    structNotify.hIcon = command3.DragIcon
	    iIconUsed = 3
	Case 3
	    structNotify.hIcon = command4.DragIcon
	    iIconUsed = 4
	Case 4
	    structNotify.hIcon = Me.Icon
	    iIconUsed = 0
    End Select
	structNotify.lFlags = NIF_ICON
	ltemplong = Shell_NotifyIcon(NIM_MODIFY, structNotify, idShell_NotifyIcon)

End Sub

Sub Command4_Click ()
    If lIconAdded < 0 Then Exit Sub  'no icons

    '-------------------------------------------
    'Deletes the last icon added
    '-------------------------------------------

    structNotify.lID = lIconAdded
    lIconAdded = lIconAdded - 1
    ltemplong = Shell_NotifyIcon(NIM_DELETE, structNotify, idShell_NotifyIcon)

End Sub

Sub Command5_Click ()
    Unload Me
End Sub

Sub Form_Load ()
    Dim lVerNum&
    Dim iVerWord%
    Dim iVersNum%
    Dim iTrueVers%
    '-----------------------------------------------------
    'First we find out what Windows is running.  This will
    'not work with 16-bit Windows 3.x, and there are a
    'couple of registry keys in Win95 that are not present
    'in Windows NT
    '-----------------------------------------------------
    lVerNum = GetVersion()
    iVerWord = CInt(lVerNum And &HFFFF&)
    iVersNum = (iVerWord And &HFF) * 100 + CInt(iVerWord / 256)
    If GetWinFlags() And WF_WINNT Then
	iWinVers = WinNT
	'The taskbar functions will not work in NT versions prior
	'to 3.51.  We need to use a 32-bit version call to find out
	'which NT is running
	iTrueVers = GetVersion32()
    Else
	'Win95 reports version 3.95
	'when queried by 16-bit programs.  It returns
	If iVersNum < 390 Then
	    iWinVers = Win16
	Else
	    iWinVers = Win32
	    'The true version isn't used by this sample application,
	    'but it is nice to see that the function works.  Set a
	    'break point after this line and look at the value for
	    'iTrueVers - it should be 400 with Win95
	    iTrueVers = GetVersion32()
	End If
    End If
    If iWinVers = Win16 Then
	MsgBox "This program is intended only for use with 32-bit Windows versions."
	Unload form1
	Exit Sub
    End If
    If iWinVers = WinNT And iTrueVers < 351 Then
	MsgBox "This program will not work on NT versions earlier then 3.51"
	Unload form1
	Exit Sub
    End If
    
    '--------------------------------------------------------
    'CALL32 requires that functions be initialized
    '--------------------------------------------------------
    
    idShell_NotifyIcon = Declare32("Shell_NotifyIcon", "shell32.dll", "ip")
    idSHAppBarMessage = Declare32("SHAppBarMessage", "shell32.dll", "ip")
    
    '--------------------------------------------------------
    'Since a user may be running 32-bit Windows but not be using
    'the Explorer shell, we use the SHAppBarMessage call to determine
    'whether there is a system taskbar.
    '---------------------------------------------------------
    structBarData.lStructureSize = 36&
    ltemplong = SHAppBarMessage(ABM_GETTASKBARPOS, structBarData, idSHAppBarMessage)
    If ltemplong <> 1 Then
	MsgBox "There is no tray currently available"
	Unload form1
	Exit Sub
    End If
    
    '----------------------------------------------------------
    'Enable the MsgHook control to receive callbacks from the taskbar
    '----------------------------------------------------------

    MsgHook1.HwndHook = Me.hWnd
    MsgHook1.Message(UM_TaskBarMessage) = True
    
    '------------------------------------------------------------
    'Set up the data structure for the Shell_NotifyIcon function
    '------------------------------------------------------------

    structNotify.lStructureSize = 88&
    structNotify.hWnd = Me.hWnd
    structNotify.lFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
    structNotify.lCallBackMessage = UM_TaskBarMessage
    structNotify.sTip = "This is a test" & Chr$(0)
    command1.Caption = "Add Icon"
    command2.Caption = "Tooltip Text"
    command3.Caption = "Change Icon"
    command4.Caption = "Delete Icon"

    lIconAdded = -1
End Sub

Sub Form_Unload (Cancel As Integer)
    '-------------------------------------------
    'We delete all icons associated with this app
    'on closing.  If we do not, the icon will remain
    'until the user moves the mouse over it.
    '-------------------------------------------
    Do Until lIconAdded < 0
	structNotify.lID = lIconAdded
	lIconAdded = lIconAdded - 1
	ltemplong = Shell_NotifyIcon(NIM_DELETE, structNotify, idShell_NotifyIcon)
    Loop
End Sub

Sub MsgHook1_Message (msg As Integer, wParam As Integer, lParam As Long, result As Long)
  Select Case msg
      Case UM_TaskBarMessage
	label4 = wParam
	Select Case lParam
	    Case WM_MOUSEMOVE
		label2 = "MOUSEMOVE"
	    Case WM_RBUTTONDBLCLK
		label2 = "RBUTTONDBLCLK"
	    Case WM_RBUTTONDOWN
		label2 = "RBUTTONDOWN"
	    Case WM_RBUTTONUP
		label2 = "RBUTTONUP"
	    Case WM_MBUTTONDBLCLK
		label2 = "MBUTTONDBLCLK"
	    Case WM_MBUTTONDOWN
		label2 = "MBUTTONDOWN"
	    Case WM_MBUTTONUP
		label2 = "MBUTTONUP"
	    Case WM_LBUTTONDBLCLK
		label2 = "LBUTTONDBLCLK"
	    Case WM_LBUTTONDOWN
		label2 = "LBUTTONDOWN"
	    Case WM_LBUTTONUP
		label2 = "LBUTTONUP"
	End Select
	Timer1.Enabled = True
  End Select

End Sub

Sub Timer1_Timer ()
    label2 = ""
    label4 = ""
    Timer1.Enabled = False
End Sub

